﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LightCube
{
    public struct LightColor
    {
        public byte A; // Not used
        public byte R;
        public byte G;
        public byte B;

        public static LightColor White = new LightColor { R = 255, G = 255, B = 255 };
        public static LightColor Black = new LightColor { R = 0, G = 0, B = 0 };

        public LightColor(byte r, byte g, byte b)
        {
            A = 0;
            R = r;
            G = g;
            B = b;
        }

        public static bool operator ==(LightColor color1, LightColor color2)
        {
            return color1.A == color2.A && color1.R == color2.R && color1.G == color2.G && color1.B == color2.B;
        }

        public static bool operator !=(LightColor color1, LightColor color2)
        {
            return color1.A != color2.A || color1.R != color2.R || color1.G != color2.G || color1.B == color2.B;
        }
    }
}
